libzypp: zypp::AutoDispose< void > Class Reference

libzypp 17.38.11

zypp::AutoDispose< void > Class Reference

`#include <zypp-core/AutoDispose.h>`

Inheritance diagram for zypp::AutoDispose< void >:

## Classes
struct | Impl

## Public Types
using | Dispose = function<void ()>
| Dispose function signatue.
using | param_type
using | reference
using | const_reference
using | value_type
using | result_type
using | dispose_param_type

## Public Member Functions
| AutoDispose ()
| Default Ctor using default constructed value and no dispose function.
| AutoDispose (const Dispose &dispose_r)
| Ctor taking dispose function and using default constructed value.
void | reset ()
| Reset to default Ctor values.
void | swap (AutoDispose &rhs) noexcept
| Exchange the contents of two AutoDispose objects.
const Dispose & | getDispose () const
| Return the current dispose function.
void | setDispose (const Dispose &dispose_r)
| Set a new dispose function.
void | resetDispose ()
| Set no dispose function.
void | swapDispose (Dispose &dispose_r)
| Exchange the dispose function.
| operator reference () const
| Provide implicit conversion to `Tp&`.
reference | value () const
| Reference to the `Tp` object.
reference | operator* () const
| Reference to the `Tp` object.
value_type * | operator-> () const
| Pointer to the `Tp` object (asserted to be != NULL).
bool | unique () const
| Returns true if this is the only AutoDispose instance managing the current data object.

## Private Attributes
shared_ptr< Impl > | _pimpl

## Detailed Description

Definition at line 203 of file AutoDispose.h.

## Member Typedef Documentation

## ◆ Dispose

using zypp::AutoDispose< void >::Dispose = function<void ()>

Dispose function signatue.

Definition at line 207 of file AutoDispose.h.

## ◆ param_type

using zypp::AutoDispose< void >::param_type

Definition at line 97 of file AutoDispose.h.

## ◆ reference

using zypp::AutoDispose< void >::reference

Definition at line 98 of file AutoDispose.h.

## ◆ const_reference

using zypp::AutoDispose< void >::const_reference

Definition at line 99 of file AutoDispose.h.

## ◆ value_type

using zypp::AutoDispose< void >::value_type

Definition at line 100 of file AutoDispose.h.

## ◆ result_type

using zypp::AutoDispose< void >::result_type

Definition at line 101 of file AutoDispose.h.

## ◆ dispose_param_type

using zypp::AutoDispose< void >::dispose_param_type

Definition at line 104 of file AutoDispose.h.

## Constructor & Destructor Documentation

## ◆ AutoDispose() [1/2]

zypp::AutoDispose< void >::AutoDispose | ( |  | ) |
| inline

Default Ctor using default constructed value and no dispose function.

Definition at line 211 of file AutoDispose.h.

## ◆ AutoDispose() [2/2]

zypp::AutoDispose< void >::AutoDispose | ( | const Dispose & | dispose_r | ) |
| inlineexplicit

Ctor taking dispose function and using default constructed value.

Definition at line 216 of file AutoDispose.h.

## Member Function Documentation

## ◆ reset()

void zypp::AutoDispose< void >::reset | ( |  | ) |
| inline

Reset to default Ctor values.

Definition at line 223 of file AutoDispose.h.

## ◆ swap()

void zypp::AutoDispose< void >::swap | ( | AutoDispose< void > & | rhs | ) |
| inlinenoexcept

Exchange the contents of two AutoDispose objects.

Definition at line 227 of file AutoDispose.h.

## ◆ getDispose()

const Dispose & zypp::AutoDispose< void >::getDispose | ( |  | ) | const
| inline

Return the current dispose function.

Definition at line 232 of file AutoDispose.h.

## ◆ setDispose()

void zypp::AutoDispose< void >::setDispose | ( | const Dispose & | dispose_r | ) |
| inline

Set a new dispose function.

Definition at line 236 of file AutoDispose.h.

## ◆ resetDispose()

void zypp::AutoDispose< void >::resetDispose | ( |  | ) |
| inline

Set no dispose function.

Definition at line 240 of file AutoDispose.h.

## ◆ swapDispose()

void zypp::AutoDispose< void >::swapDispose | ( | Dispose & | dispose_r | ) |
| inline

Exchange the dispose function.

Definition at line 244 of file AutoDispose.h.

## ◆ operator reference()

zypp::AutoDispose< void >::operator reference | ( |  | ) | const
| inline

Provide implicit conversion to `Tp&`.

Definition at line 134 of file AutoDispose.h.

## ◆ value()

reference zypp::AutoDispose< void >::value | ( |  | ) | const
| inline

Reference to the `Tp` object.

Definition at line 138 of file AutoDispose.h.

## ◆ operator*()

reference zypp::AutoDispose< void >::operator* | ( |  | ) | const
| inline

Reference to the `Tp` object.

Definition at line 142 of file AutoDispose.h.

## ◆ operator->()

value_type * zypp::AutoDispose< void >::operator-> | ( |  | ) | const
| inline

Pointer to the `Tp` object (asserted to be != NULL).

Definition at line 146 of file AutoDispose.h.

## ◆ unique()

bool zypp::AutoDispose< void >::unique | ( |  | ) | const
| inline

Returns true if this is the only AutoDispose instance managing the current data object.

Definition at line 158 of file AutoDispose.h.

## Member Data Documentation

## ◆ _pimpl

shared_ptr<Impl> zypp::AutoDispose< void >::_pimpl
| private

Definition at line 264 of file AutoDispose.h.

The documentation for this class was generated from the following file:

- zypp-core/AutoDispose.h